/* ***************************** *
 *  MH-6.8.x 日本語版の歴史(笑)  *
 * ***************************** */

/* [2001-09-07] mh-6.8.4-JP-3.05  (by MH-plus project) */

  ○Linux で RPOP 付きで make し、RPOP を使わずに NFS クライアントで inc
    すると(上記全ての条件が一致した時だけ)、カレントメッセージが移動しな
    いバグを修正。
  ○2001年になると、Date 行の二桁年 "01" は 1900年代と解釈してしまう問題を
    修正。(2000年では問題無かったのに 2001年問題? ^^;;)
  ○ハッシュ値が等しくなる二つのヘッダの内、どちらかが存在するかどうかを
    チェックするような mh-format を書くと core dump する問題を修正。
  ○Solaris 2.x でファイルロックが不充分だった問題を修正。
  ○mhn での MIME タイプ名のクォートに関するセキュリティホールを修正。
  ○HP-UX の ruserpass() が MH の期待する動作をしない問題を修正。
  ○mhmail や rcvdist で .mh_profile の signature や sendername が効かな
    かった問題を修正。
  ○slocal のパターンマッチを日本語対応にした。
  ○取り敢えず、read 時だけ JIS X 0213 用の "ESC $ ( O" も JIS X 0208 と
    同一視して解釈出来るようにした(これで第1〜2水準だけは化けない)。
  ○configure で --disable-japan が選択できるようにした。実行時に環境変数
    MM_CHARSET に ISO-8859-x のどれかをセットしてると ISO-8859-x 対応に
    なります。
  ○make depend が正しく働くようにした。
  ○その他、対応 OS をちょっと増やす。:-)


/* [2000-10-03] mh-6.8.4-JP-3.04  (by Takashi SHIRAI) */
/*       ちなみに、このバージョンには MH-plus project は絡んでません。 */

  ○envelope from の user name を localhost の user name と異なる設定に
    出来るように、mtstailor/localuser と .mh_profile/Sendername を追加。
  ○From: を明示しなかった場合に自動的に付加される際の address を
    .mh_profile/From-Address で指定可能にした。
  ○mh-format 内で date2local() を使うと発生する 2000年問題を修正。


/* [1999-10-04] mh-6.8.4-JP-3.03  (by MH-plus project) */

  ○SunOS 4.x や Linux で RPOP が使えなくなってた問題を修正。(すみません。
    エンバグしてました)
  ○pick で JIS コードでの検索が出来なくなってた問題を修正。(すみません。
    エンバグしてました)
  ○Linux で特定のメールに対して scan が core dump する事がある問題を修正。
  ○repl & mh-format でコンポーネント末尾に余分な空白がつく問題を修正。
  ○値を返さない関数から値を受けとるような mh-format を書くと、core dump
    したり、無限ループになったりする問題を修正。
  ○inc で lock file を2回 close しようとしてた問題を修正。
  ○From: に RFC の規定より長い MIME encoded-word があるメールに repl する
    と draft の To: 行が乱れる事がある問題を修正。
  ○%(putaddr) で画面幅より長いヘッダ名を指定すると core dump する問題を
    修正。
  ○glibc2.1 の文字列関数との相性が悪かったのを修正。
  ○autoconf を 2.13 に上げる。
  ○その他、対応 OS をちょっと増やす。:-)


/* [1999-02-09] mh-6.8.4-JP-3.02  (by MH-plus project) */

  ○Linux 上で、~/.mh_profile の最後が改行で終ってないと全てのコマンドが
    core dump する問題を修正。(Linux 特有?)
  ○mh-format で 1000000000 以上の数(int が 32bit の場合)を桁数指定せずに
    表示させようとするとおかしな数になったり、無限ループになる問題を修正。
  ○sizeof(long) と sizeof(time_t) が異なる環境で時間がおかしくなる問題を修正。
  ○long が 32bit だと決め打ちしていた問題を修正。
  ○vmh が SunOS 4.x 以外ではまともに動かない問題を修正。
  ○Digital UNIX で、vmh が make 出来ない問題を修正。
  ○vmh を日本語対応に(表示は JEUC のみ)。vmh の日本語マニュアルも追加。
  ○~/.mh_profile に「show: -form hogehoge」とか書いてる場合に、
    「show -noshowproc」がうまく実行できない問題を修正。
  ○options SETEUID と SETREUID を追加。特定の OS では、options RPOP 時に、
    inc や msgchk は、実行直後に一旦権限を落し、特権ポートを開く時だけ
    root 権限に戻るようにした。(sendmail の test/Results 参照)
  ○structured header で日本語文字の直後に ')' があるようなものを MIME encode
    させると、core dump することがある問題を修正。
  ○フォルダ内が JIS7 以外の日本語環境で forw -mime をしてから mhn -junet
    をしても、取り込まれたメッセージが JIS7 にならない問題を解決。
  ○edit mhn で application/* タイプのデータを取り込む際、8bit コードを含ま
    ないデータだと '\0' を含んでいても encode されない問題を解決。(生の '\0'
    は転送時に化ける)
  ○multipart の一部のパートが 8bit になってる場合でも、トップレベルが
    7bit のままになってた問題を解決。(cf. RFC-2045)
  ○multipart の delimiter の後ろに余分なスペースがあると delimiter として
    認識されない問題を解決。(cf. RFC-2046)
  ○inc で lock file によるロックをした場合、inc が異常終了すると lock file
    が消されずに終了してしまう事がある問題を修正。
  ○trim で右寄せ桁数指定をした場合、切りとられる位置に日本語があると文字
    化けする問題を修正。
  ○showproc を mhl にしてる時に、msh をフォルダーモードで起動し show する
    と、表示が終った後 core dump する問題を修正。
  ○bbc で LISTGROUP コマンド(RFC-977 に無い拡張コマンドだがほとんどの NNTP
    サーバーでサポートされている)をサポートしてない NNTP サーバーにはうまく
    接続できない問題を修正。
  ○bbc で NNTP 接続した際、scan 時に存在した記事が show した時には expire
    されてた…とか、あるはずの記事が途中で無くなると、bbc が落ちてしまう
    問題を修正。


/* [1998-12-02] mh-6.8.4-JP-3.01  (by MH-plus project) */

  ○options RPOP 時に発生する inc や msgchk のセキュリティ・ホールを修正。
  ○長い MIME ヘッダー行で buffer overrun が発生するセキュリティ・ホールを
    修正。
  ○options JAPAN をつけて、options MIME_HEADERS をつけない場合に、Subject:
    等に生の JIS コードを書いたメールを post すると、JIS7 で出ていかずに、
    JEUC になってしまうというバグを修正。
  ○空のヘッダーがあると pgped が core dump する問題を修正。
  ○「inc -file hoge -truncate」は効くのに「inc -truncate -file hoge」は
    -truncate オプションが無視される問題を解決。
  ○mhparam で、デフォルト値のある proc コンポーネントのうちデフォルトのままに
    しているものを表示させようとすると、core dump する問題を解決。
  ○digestcomps の 2000年問題を解決。:-)
  ○SJIS 環境で mhn エディットすると、MIME エンコードされた
    Content-Description: ヘッダーが化ける問題を修正。
  ○mhl に decode オプションを追加。
  ○post のデフォルトの動作を、ドラフトに MIME-Version: ヘッダーがある時
    には -hencode、ない時には -nohencode になるように変更。
  ○mhn エディットの際に MM_CHARSET=iso-2022-jp の時には 8bit メールに 7bit
    と表示するように。(post 後に sendmail 等で EUC→JIS7 変換がされる場合へ
    の対策)
  ○pgped のデフォルトを -mime に変更。
  ○PGP5 に一応対応。
  ○send 及び mhn の message/partial 関係を RFC-2046 対応に。
  ○mhn_defaults 内に「mhn-show-multipart/mixed」等を設定しても無視されて
    いた問題を解決。
  ○FreeBSD 等では gzip された man をインストールするように。
  ○POP(クライアント)機能を on にするが、POPサーバー関係をインストールしない
    という選択が可能に。
  ○configure のデフォルトを --enable-pop --enable-apop --disable-popserver
    にする。
  ○vmh.c が glibc2 で make 出来ない問題を解決。(でも、元々 vmh 自体使えない
    から特に意味なし :-p)
  ○Solaris 2.5.1 → 2.6 の仕様変更で libzot.a が make 出来ない問題に対応。
  ○BSD/OS では shlicc2 を使うように。
  ○OPENSTEP の lockf() が broken だ…対策。
  ○Linux の ruserpass() が MH のものと仕様が違う…対策。
  ○タイムゾーン取得の際、SYS5 だけど ZONEINFO 機能がある OS を考慮して、
    ZONEINFO オプションを優先させるようにする。
  ○日本語オンライン・マニュアルを作成。


/* [1998-04-24] mh-6.8.4-JP-3.00  (by MH-plus project) */
/*             このバージョンからは mh-68-jp ML と     */
/*                MH-plus project が統合されています。 */

  ○ベースを mh-6.8.4 に上げた。
  ○mark の core dump 対策で、エンバグしてた部分を修正。
  ○APOP が古い db だけを想定してたので、ndbm にも対応させる。
  ○POP を define し、RPOP を define してなくても、POP のデフォルト
    が RPOP になるのを修正。
  ○mhn で multipart/foo などを multipart/mixed 扱いにする。(RFC-2046)
  ○mhn で text/foo などを text/plain 扱いにする。(RFC-2046)
  ○sendmail のパスが "/usr/lib/sendmail" と決め打ちされてる点を修正。
  ○chgrp のパスが "/bin/chgrp" と決め打ちされてる点を修正。
  ○FreeBSD などで conflict を実行すると、/usr/spool/mail が無いと言われる
    問題を修正。
  ○リトルエンディアンのマシンで、msh で MMDF 形式のファイルを scan する
    と last のメッセージがうまく表示できない問題を修正。
  ○SVR4 のロングタイプの utmp に対応。
  ○OS によっては popauth で APOP のデータベースファイルを初期化できない
    問題を修正。
  ○mhn -list で multipart なメールのパート一覧を見た時、各パートに付いて
    いる Content-Description: ヘッダーの内容が MIME エンコードされている場合、
    それがデコードできない問題を修正。
  ○inc や scan の時、何のオプションも指定してない場合は MIME デコードする
    ように修正。
  ○pick で MIME エンコードされたヘッダーを検索できるように修正。
  ○options MIME の時、charset=ISO-2022-JP が付いたメールを show すると、
    いちいち mhn を呼んで、ヘッダとボディを分割するのをやめるように修正。
  ○rcvtty は EUC しか表示できない問題を修正。また、何のオプションも指定
    されてない時は MIME ヘッダーのデコードをするように…。
  ○mhn で compose した時(whatnow から edit mhn など)には、ヘッダーを
    MIME エンコードするようにした。
  ○mhn で compose した時には、SMTP で転送できないぐらい一行が長い text/plain
    はエンコードする事にした。
  ○MIME ヘッダーの language 拡張に対応。(RFC-2231)
  ○mhl 用のフォーマット mhl.format, mhl.headers は hdecode() 入りをインス
    トール。
  ○mhn に自動 JIS コード変換をする -junet オプションと、生の 8bit を許す
    -8bit オプションを付けた。
  ○inc が SetUID root されるのは RPOP の時だけにした。
  ○bbc でニュースグループを指定しないと OS によっては core dump する問題
    を解決。
  ○bbc が NNTP 接続の時に、使いもしないパスワードをいちいち聞いてくる
    のをやめるようにした。
  ○options NNTP を BPOP から独立。単独で NNTP を指定できるように。
  ○mh-format の hencode, hdecode 関数を RFC-2047 対応に。
  ○pick の検索文字列は Mule の内部コードでもOKに。(Mule + MH-e のバグ対策)
  ○型の違いをうまく cast 出来てない部分を修正。
  ○m_atoi() が options LOCALE をセットしてるかどうかによって挙動が変わる
    問題を修正。
  ○options MIME だと MIME に対応せず、options MIME じゃないと対応すると
    いう風に逆になってた部分を修正。
  ○options READLINE 追加。msh がヒストリやフォルダー名補完等が出来るように。
  ○コメント等の typo を修正。
  ○mhl で BUFSIZ 以上の長さのヘッダーを mh-format で処理しようとすると、
    BUFSIZ でぶち切れる問題を修正。
  ○mh-format で BUFSIZ 以上の長さの文字列を hdecode などすると、core dump
    する問題を修正。
  ○Solaris で行頭に # をおいた日本語メールを mhn エディットすると、core
    dump する事があるという問題を修正。
  ○lex の失敗チェック部分を厳しく。
  ○folder コマンドが 300個以上のフォルダーを認識できない問題を修正。
  ○mhpath コマンドが 998個以上のメッセージを認識できない問題を修正。
  ○slocal の -file オプションがまともに働かない問題を修正。
  ○slocal -debug が ~/.maildelivery のフォーマット間違いには何の警告も出さ
    ない問題を修正。
  ○slocal -debug で sender が分からないメールが送られてくると core dump
    する問題を修正。
  ○options SETMG 時の slocal のセキュリティホールを修正。
  ○rcvtty が BSD 以外のマシンでは動かない問題を修正。
  ○~/Mail/inbox/.mh_sequences などが一行 BUFSIZ*2 文字以上になると、
    「inbox/.mh_sequences is poorly formatted」などと出て、MH シーケンスが
    使えなくなる問題を修正。
  ○FreeBSD の日本語環境で、「File-Coding: ja_JP.JIS7」等の設定をしてない
    と MH-e でうまく日本語が表示できない場合があるという問題への対策。
  ○漢字コードは $LANG や $LC_CTYPE などは見ないようにする。
  ○solaris_gethostbyname() を sendmail-8.8.8 を元に書き換え直し。
  ○rmm で Trash-Folder: (ゴミ箱フォルダー)の設定が出来るように。
  ○pgped/pgpshow を multipart/signed、multipart/encrypted に対応。
  ○multipart/* (mixed, alternative, digest, parallel 以外)を mhn で show
    する際に、mhn_defaults に指定 multipart の show の設定がある場合、指定
    プログラムにはデコード後の content ではなく、生の content を渡すように
    変更。(電子署名されたものを閲覧する場合などへの対策)
  ○curses が ncurses であっても、一応 make は通るように。
  ○HP-UX で SYS5DIR を define しても大丈夫なように。
  ○FreeBSD で APOP が core dump する問題に対処。
  ○Linux でのディレクトリ構造体の問題を修正。
  ○Linux で shared ライブラリを作るようにする。
  ○IRIX の char は unsigned char だ…という問題に弱々な対応。
  ○mhn -list の際、message/rfc822 の multipart の場合、Content-Description:
    ヘッダーがない時は、message 部分の Subject: を見る。
  ○mhn で、コメントの parse を RFC-2045 の記述どおりにするようにした。
  ○「Content-Transfer-Encoding: binary」に対応。但し、binary の multipart
    には非対応。
  ○MPOP を BPOP から独立。以前に jp2c+-1.02 で追加した MPOP 定義下で BPOP
    非定義の警告を解除。
  ○AliasFile の中に日本語を書けるようにした。但し、post に -hencode を付け
    て置く必要あり。
  ○mhn は「ヘッダーの MIME encoded-word を含む行は一行76文字以内にすること」
    …という RFC に従って encode するのに、post -format すると、勝手に行を
    繋げて、76文字以上になってしまう問題を修正。
  ○mhl で mh-format を使った際に、format 後のヘッダが format 前のヘッダ
    より長くなる場合に core dump する事があるバグを修正。
  ○HP-UX 10.x で options RPATHS の場合、Return-Path: 行にゴミが残ってしまう
    問題を修正。
  ○From: 行に、やたらと長い継続行のコメントがついてるようなメールに対し
    repl すると、変な位置に数千行ぐらいの空行が出力されたりする問題を修正。


/* [1997-10-07] mh-6.8.3+-jp2c+-1.03  (by MH-plus project) */

  ○ソース中で "/etc/utmp" と utmp のパスを決め打ちしてる問題を修正。
  ○FreeBSD で packf が core dump する不具合を修正。
  ○SJIS 環境で repl の際にヘッダの漢字が化けることがある不具合を修正。
  ○hdecode 関数を "Q" encoding まで拡張。
  ○MIME encoded-word が 2byte文字の途中で分割されてると文字化けするのを修正。
  ○mhn が 7bit メールは全て ISO-2022-JP だと思ってしまう問題を修正。
    デフォルトは charset="us-ascii" に戻す。
  ○mh-format で表示できない漢字がある場合、それ以後が空白になる問題を修正。
  ○options CONTENT_LENGTH 時に、packf したファイルを msh で scan すると、
    Content-Length: がらみの警告が出る問題を修正。


/* [1996-08-28] mh-6.8.3+-jp2c+-1.02  (by MH-plus project) */

  ○Linux への対応。
  ○FreeBSD で APOP 付きの make が通るよう dbm 回りを変更。
  ○pick が各行1024文字目以降を検索しない不具合を修正。(ヘッダーの継続行は
    繋いでから検索してるので、何行にも渡る継続行のあるヘッダーでは 1024文字
    を越える事があります)
  ○pick に与える正規表現で前に文字のない '*' を使うと core dump する問題修正。
  ○slocal で '+' を指定すると、rcvstore を起動するように。
  ○options CONTENT_LENGTH 時に、メールをスプールと違う漢字コードで
    フォルダーにセーブすると、Content-Length: ヘッダの byte 数がずれて、
    エラーが出る問題を修正。
  ○slocal の destroy 回りの不具合を fix。
  ○options FILBUF_ADJ 追加。_filbuf() の仕様の違いを吸収。
  ○GNU make でも make 出来るように修正。
  ○MPOP, BPOP の依存関係を満たしてないと mhconfig 時にエラーを返すよう変更。
  ○mhlで、mail header 部がBUFSIZ(=1024)以上の時、body が化ける不具合の修正。
  ○mhlで、長い行があると core を吐いたり文字化けしたりする不具合を修正。
  ○一部の OS で、タイムゾーンに JST と書かれたメールが sortm でうまく時間
    順に並ばない不具合を修正。
  ○pick で日本語を含んだ文字列を検索できるように修正。正規表現も日本語対応。
  ○SJIS 回りの漢字コード変換ルーチン等のバグ修正。
  ○strcasecmp() を uleq() で書き換え。
  ○MAILGROUP と POP を両方指定してる時に saved GID が落ちる問題を修正。


/* [1995-08-01] mh-6.8.3+-jp2c+  (by MH-plus project) */
/*       記述はありませんがこの日付で公開されたものは */
/*                                  jp2c+-1.01 です。 */

  ○Solaris 2.x への対応。
  ○FreeBSD への対応。
  ○options CONTENT_LENGTH 追加。Solaris 2.x などの Content-Length:
    ヘッダーに対応。
  ○options SETMG を追加。slocal を mail に SetGID 出来るようにする。
    (セキュリティ的には問題があるかも知れない)
  ○options NORESPOST を追加。post 作成時に -lresolv をつけないように出来る。
    (/etc/hosts や DNS の見に行く順序を自由に設定できる OS では意味なし)
  ○Solaris 2.x で POP が使えるようにする。
  ○Solaris 2.x や FreeBSD で shared library が使えるように…。
  ○Solaris 2.x で .mh_sequences のないフォルダーを mark すると core dump
    する問題の対策。(これはその後 mh-6.8.4 で修正されました)
  ○slocal のファイルロック関係の修正。
  ○sendmail との SMTP connection で、MH が HELO/EHLO を言わない問題の対策。
  ○ヘッダ中のコメント折り曲げ時の不具合修正。
  ○folder -fast -recurse の際、ディレクトリのリンク数が2なら、サブ
    ディレクトリを検索しないように。
  ○trim が core dump する問題を修正。
  ○Solaris 2.x の gethostby{addr|name}関数が FQDN を返さないバグ対策。
  ○mhn 中の si_key 等の変数混同バグを修正。
  ○post -hencode 時にヘッダーに TAB と space だけの行が出来てしまう事が
    ある問題を修正。


/* [1995-05-23] mh-6.8.3+-jp2c+  (by MH-plus project の前身 ^^;;) */
/*             jp2c+-1.01 以前は名前が同じなので、ややこしい。:-) */

  ○HP-UX への対応。バグフィックス等。


/* [1993-12-??] mh-6.8.3-JP.2c  (by どなたでしょう? ^^;;) */
/*             ちなみに、このバージョンには mh-68-jp ML も */
/*                        MH-plus project も絡んでません。 */

  ○ベースを mh-6.8.3 に上げる。(mh-6.8.3 に mh-6.8-JP2c パッチを当てた模様)


/* [1993-08-20] mh-6.8-JP2c  (by mh-68-jp ML) */

  ○mhl の改行処理のバグ修正。
  ○install-mh が abort する問題を修正。


/* [1993-02-14] mh-6.8-JP2  (by mh-68-jp ML) */

  ○Shift JIS コードに対応。
  ○mhl を日本語対応に。
  ○MIME ヘッダーを encode/decode 出来るように。
  ○mhn で edit した時のデフォルトを charset="iso-2022-jp" に。


/* [1992-12-21] mh-6.8-JP1  (by mh-68-jp ML) */

  ○inc や scan で日本語文字(JIS コード)が含まれていても文字化けしないように。
  ○mh-format 中で日本語文字が使えるように。
  ○timezone "JST" を認識するように。


/* MH-plus project <mh-plus@ml.chem.eng.himeji-tech.ac.jp> */
